variables:
  DOCKER_REGISTRY: "registry.gitlab.com"
  CONTAINER_PATH: "opentap/plugins/5g-ppp-test-measurement-and-kpis-validation-wg/5gppp-tmv-basic-testing-bundle"
  REPO_URL: 'packages.opentap.io'
#----------------------------------------------------------------------------------------------------------------------

stages:
  - prebuild
  - build
  - tests

#----------------------------------------------------------------------------------------------------------------------  


#############################################
# Stage: prebuild                           #
#############################################
BuildUmaPlugins:
  stage: prebuild
  image: opentapio/opentap:9.12-ubuntu18.04
  tags: [docker]
  script:
    - apt-get install -y dotnet-sdk-3.1
    #### uma.influx
    - git clone https://gitlab.com/OpenTAP/Plugins/university-of-malaga/uma-influxdb-result-listener.git
    - cd uma-influxdb-result-listener/
    - dotnet publish -c Release
    - cd ..
    - cp uma-influxdb-result-listener/Tap.Plugins.UMA.InfluxDb/bin/Release/Tap.Plugins.UMA.InfluxDb.*.TapPackage .
    #### uma.android
    - git clone https://gitlab.com/OpenTAP/Plugins/university-of-malaga/uma-android.git
    - cd uma-android/Tap.Plugins.UMA.Android
    - dotnet publish -c Release
    - cd ../..
    - cp uma-android/Tap.Plugins.UMA.Android/Tap.Plugins.UMA.Android/bin/Release/netstandard2.0/UMA.Android.*.TapPackage .
    - cp UMA.Android.*.TapPackage $TAP_PATH
    #### uma.adbagents
    - git clone https://gitlab.com/OpenTAP/Plugins/university-of-malaga/uma-adb-agents.git
    - cd uma-adb-agents/Tap.Plugins.UMA.AdbAgents
    - dotnet publish -c Release
    - cd ../..
    - cp uma-adb-agents/Tap.Plugins.UMA.AdbAgents/Tap.Plugins.UMA.AdbAgents/bin/Release/netstandard2.0/UMA.AdbAgents.*.TapPackage .
  artifacts:
    expire_in: 1 day
    paths:
       - "*.TapPackage"
    reports:
      dotenv: prebuild.env
#----------------------------------------------------------------------------------------------------------------------  


BuildPluginBundle:
  stage: prebuild
  image: opentapio/opentap:9.12-ubuntu18.04
  tags: [docker]
  script:
    - git fetch origin master
    - export projDir=$(pwd)
    - /opt/tap/tap package install -f -v -r $REPO_URL --version "any" "SSH"
    - /opt/tap/tap package install -f -v -r $REPO_URL --version "any" "Iperf"
    - /opt/tap/tap package install -f -v -r $REPO_URL --version "any" "TUI"
    - /opt/tap/tap package install -f -v -r $REPO_URL --version "any" "Yardstick"
    - /opt/tap/tap package install -f -v -r $REPO_URL --version "any" "OpenStackHeat"
    - /opt/tap/tap package list -i
    - echo "BUILD_VERSION=$(/opt/tap/tap sdk gitversion)" >> prebuild.env
    - /opt/tap/tap package create -v $projDir/HelloTestPluginBundle/bundle.package.xml --project-directory $projDir
  only:
    - master
  artifacts:
    expire_in: 1 day
    paths:
       - "*.TapPackage"
    reports:
      dotenv: prebuild.env
#----------------------------------------------------------------------------------------------------------------------  

#############################################
# Stage: build                              #
#############################################
BuildOpenTAPContainer:
  stage: build
  image: docker:latest
  tags: [docker]
  dependencies:
    - BuildPluginBundle
    - BuildUmaPlugins
  before_script:
    - echo "$CI_JOB_TOKEN" | docker login -u gitlab-ci-token --password-stdin $DOCKER_REGISTRY
  services:
    - docker:dind
  script:
    - echo $BUILD_VERSION
    - export DOCKER_IMAGE_TAG_CURRENT=$(echo $BUILD_VERSION | cut -d'+' -f 1)
    - echo $DOCKER_IMAGE_TAG_CURRENT
    - echo $CI_COMMIT_SHA
    - export DOCKER_IMAGE_NAME=$CONTAINER_PATH/opentap
    - cp *.TapPackage opentapcontainer/
    - cp opentapplans/hellotest-iperf-example.TapPlan opentapcontainer/
    - cp opentapsettings/Bench opentapcontainer/ -r
    - cd opentapcontainer
    - docker build -t $DOCKER_REGISTRY/$DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG_CURRENT .
    - docker push $DOCKER_REGISTRY/$DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG_CURRENT
    - docker logout $DOCKER_REGISTRY
    - cd ..
    - echo "IMAGE_OPENTAP=$DOCKER_REGISTRY/$DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG_CURRENT" > opentapbuild.env
  only:
    - master
  artifacts:
    expire_in: 1 day
    paths:
      - "opentapbuild.env"


#----------------------------------------------------------------------------------------------------------------------  

BuildToolsContainer:
  stage: build
  image: docker:latest
  tags: [docker]
  before_script:
    - echo "$CI_JOB_TOKEN" | docker login -u gitlab-ci-token --password-stdin $DOCKER_REGISTRY
  services:
    - docker:dind
  script:
    - export DOCKER_IMAGE_TAG_CURRENT=$(echo $BUILD_VERSION | cut -d'+' -f 1)
    - echo $DOCKER_IMAGE_TAG_CURRENT
    - echo $CI_COMMIT_SHA
    - export DOCKER_IMAGE_NAME=$CONTAINER_PATH/tools
    - cd toolscontainer
    - docker build -t $DOCKER_REGISTRY/$DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG_CURRENT .
    - docker push $DOCKER_REGISTRY/$DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG_CURRENT
    - docker logout $DOCKER_REGISTRY
    - cd ..
    - echo "IMAGE_TOOLS=$DOCKER_REGISTRY/$DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG_CURRENT" > toolsbuild.env
  only:
    - master
  artifacts:
    expire_in: 1 day
    paths:
      - "toolsbuild.env"

#----------------------------------------------------------------------------------------------------------------------  

#############################################
# Stage: tests                              #
#############################################
testscontainers:
  stage: tests
  image: docker/compose:latest
  tags: [docker]
  dependencies:
    - BuildOpenTAPContainer
    - BuildToolsContainer
  before_script:
    - echo "$CI_JOB_TOKEN" | docker login -u gitlab-ci-token --password-stdin $DOCKER_REGISTRY
  services:
    - docker:dind
  script:
    - export $(tail toolsbuild.env)
    - export $(tail opentapbuild.env)
    - docker-compose -f test/docker-compose.yml up -d
    - docker exec -i opentap tap run -v --settings /opt/tap/Settings/hellotest-bench -e "Test Duration DL"=12 -e "Test Duration UL"=14 /opt/tap/hellotest-iperf-example.TapPlan
    - docker logout $DOCKER_REGISTRY
  only:
    - master
#----------------------------------------------------------------------------------------------------------------------

